'dwukierunkowy licznik 8-cyfrowy zliczajcy ipulsy podawane na wejcia portd.2
'lub portd.3 z regulacj intensywnoci wiecenia wywetlaczy LED
'**********                   Nowak Mariusz                   *********
'************              nowak_mariusz@op.pl                *********
'**********                   GG: 1234345                     *********

$regfile = "m8DEF.DAT"
$lib "mcsbyte.lbx"
$crystal = 8000000

Config Portb = Output : Portb = 255
Config Pind.2 = Input : Portd.2 = 1
Config Pind.3 = Input : Portd.3 = 1
Config Pind.4 = Input : Portd.4 = 1
Config Pind.5 = Input : Portd.5 = 1
Config Spi = Soft , Dout = Portd.0 , Clock = Portd.1 , Ss = Portd.6

S1 Alias Pind.2
S2 Alias Pind.3
S3 Alias Pind.4
S4 Alias Pind.5

Declare Sub Wyswietl_liczbe(l As Long)
Declare Sub Jasn

Dim Bit1 As Bit
Dim Bit3 As Bit
Dim Bit4 As Bit
Dim Bit5 As Bit
Dim Liczba As Long
Dim Jasnosc As Byte
Dim Y As Word

Spiinit

Y = &H010F : Spiout Y , 2                                   'ZAPISUJE DO REJESTRU "DISPLAY TEST" TRYB TESTU
Wait 1                                                      'ODCZEKAJ SEKUNDE
Jasnosc = 15                                                'USTAWIENIE NAJWIKSZEJ INTENSYWNOCI WIECENIA

   Y = &H000F : Spiout Y , 2                                'ZAPISUJE DO REJESTRU "DISPLAY TEST" TRYB NORMALNY
   Y = &H010C : Spiout Y , 2                                'SHUTDOWN NORMAL
   Y = &H070B : Spiout Y , 2                                'WLACZA WSZYSTKIE LED
   Y = &HFF09 : Spiout Y , 2                                'WSZYSTKIE LED DEKODUJE W BCD

Do
   If S1 = 0 Then
      If Bit1 = 1 Then
         Incr Liczba
         If Liczba > 99999999 Then Liczba = 0
         Bit1 = 0
      End If
   Else
      Bit1 = 1
   End If
   If S2 = 0 Then
      If Bit3 = 1 Then
         Decr Liczba
         If Liczba < 0 Then Liczba = 99999999
         Bit3 = 0
      End If
   Else
      Bit3 = 1
   End If
   Call Wyswietl_liczbe(liczba)
   If S3 = 0 Then
      If Bit4 = 1 Then
         If Jasnosc < 15 Then Incr Jasnosc
         Bit4 = 0
      End If
   Else
      Bit4 = 1
   End If
   If S4 = 0 Then
      If Bit5 = 1 Then
         If Jasnosc > 0 Then Decr Jasnosc
         Bit5 = 0
      End If
   Else
      Bit5 = 1
   End If
   Call Jasn
Loop

Sub Jasn
Dim A As Byte
   Y = Makeint(&H0a , Jasnosc) : Spiout Y , 2
End Sub

Sub Wyswietl_liczbe(l As Long)                              'PROCEDURA WYWEITLAJCA NA WYWIETLACZU LED LICZB TYPU LONG

Dim Z As Byte
Dim X As Word
Dim Wartosc As Long
Dim Temp As Long
Dim Bit2 As Bit

   Wartosc = L
   Bit2 = 0
   If Wartosc < 10000000 Then
      X = &H0F08 : Spiout X , 2
   Else
      Temp = Wartosc / 10000000
      Z = Low(temp)
      X = Makeint(&H08 , Z) : Spiout X , 2
      Wartosc = Wartosc Mod 10000000
      Bit2 = 1
   End If
   If Wartosc < 1000000 And Bit2 = 0 Then
      X = &H0F07 : Spiout X , 2
   Else
      Temp = Wartosc / 1000000
      Z = Low(temp)
      X = Makeint(&H07 , Z) : Spiout X , 2
      Wartosc = Wartosc Mod 1000000
      Bit2 = 1
   End If
   If Wartosc < 100000 And Bit2 = 0 Then
      X = &H0F06 : Spiout X , 2
   Else
      Temp = Wartosc / 100000
      Z = Low(temp)
      X = Makeint(&H06 , Z) : Spiout X , 2
      Wartosc = Wartosc Mod 100000
      Bit2 = 1
   End If
   If Wartosc < 10000 And Bit2 = 0 Then
      X = &H0F05 : Spiout X , 2
   Else
      Temp = Wartosc / 10000
      Z = Low(temp)
      X = Makeint(&H05 , Z) : Spiout X , 2
      Wartosc = Wartosc Mod 10000
      Bit2 = 1
   End If
   If Wartosc < 1000 And Bit2 = 0 Then
      X = &H0F04 : Spiout X , 2
   Else
      Temp = Wartosc / 1000
      Z = Low(temp)
      X = Makeint(&H04 , Z) : Spiout X , 2
      Wartosc = Wartosc Mod 1000
      Bit2 = 1
   End If
   If Wartosc < 100 And Bit2 = 0 Then
      X = &H0F03 : Spiout X , 2
   Else
      Temp = Wartosc / 100
      Z = Low(temp)
      X = Makeint(&H03 , Z) : Spiout X , 2
      Wartosc = Wartosc Mod 100
      Bit2 = 1
   End If
   If Wartosc < 10 And Bit2 = 0 Then
      X = &H0F02 : Spiout X , 2
   Else
      Temp = Wartosc / 10
      Z = Low(temp)
      X = Makeint(&H02 , Z) : Spiout X , 2
      Wartosc = Wartosc Mod 10
      Bit2 = 1
   End If
   Z = Low(wartosc)
   X = Makeint(&H01 , Z) : Spiout X , 2
End Sub